if(typeof(ic) === 'undefined') ic = {};
ic.TaskClass = {
	Unknown : 0,
	EventManager : 10,
	Update : 11,
	License : 12,
	ODS : 256,
	OAS : 257,
	Quarantine : 258,
	EventStorage : 259,
	Notifier : 260,
	AVS : 261,
	Statistics : 262,
	QS : 263,
	Snmp : 264
}; // ic.TaskClass

ic.TaskState = {
	Stopped : 1,
	Stopping : 2,
	Started : 3,
	Starting : 4,
	Suspended : 5,
	Suspending : 6,
	Resumed : 7,
	Resuming : 8,
	Failed : 9,
	Unknown : 0
}; // ic.TaskState

ic.FSType = {
	Local : 1,
	Mounted : 2,
	Shared : 3,
	AllRemotelyMounted : 4,
	AllShared : 5
}; // ic.FSType

ic.FSName = {
	Any : 1,
	Samba : 2,
	Nfs : 3
}; // ic.FSName

ic.VerdictType = {
	Undefined : 0,
	Virware : 6,
	Trojware : 5,
	Malware : 4,
	Adware : 3,
	Pornware : 2,
	Riskware : 1
}; // ic.VerdictType

ic.OAS = {};
ic.OAS.Action = {
	Cure : 1,
	Remove : 2,
	Recommended : 3,
	Quarantine : 4,
	Skip : 5
}; // ic.OAS.Action

ic.OAS.AccessType = {
	SmartCheck : 1,
	Open : 2,
	OpenAndModify : 3
}; // ic.OAS.AccessType

ic.BLError = {
	Unknown : 0,
	Network : 1,
	Failed : 2,
	TaskNotFound : 3,
	NotAllowed : 4,
	TaskAlreadyStarted : 5,
	TaskNotStarted : 6,
	LicenseError : 7,
	SettingsError : 8,
	NotImplemented : 999
}; // ic.BLError

ic.ScanPriority = {
	High : 4,
	Medium : 3,
	Low : 2,
	System : 1
}; // ic.ScanPriority

ic.QStatus = {
	Clean : 1,
	Backup : 2,
	Infected : 3,
	UserAdded : 4,
	Curable : 5,
	Error : 6,
	PasswordProtected : 7,
	Corrupted : 8
}; // ic.QStatus

ic.DangerLevel = {
	Unknown : 0,
	High : 1,
	Medium : 2,
	Low : 3,
	Info : 4
}; // ic.DangerLevel

ic.DetectCertainty = {
	Unknown : 0,
	Sure : 1,
	Warning : 2,
	Suspicion : 3
}; // ic.DetectCertainty

ic.ProxyAuthType = {
	NotRequired : 0,
	Ntlm : 1,
	Plain : 2,
	NtlmWithCredentials : 3
}; // ic.ProxyAuthType

ic.OASAccessType = {
	SmartCheck : 1,
	Open : 2,
	OpenAndModify : 3
}; // ic.OASAccessType

ic.EventStorageRotateMethod = {
	Erase : 1,
	Move : 2
}; // ic.EventStorageRotateMethod

ic.EventStorageRotatePeriod = {
	Daily : 1,
	Weekly : 2,
	Monthly : 3,
	Never : 4
}; // ic.EventStorageRotatePeriod

ic.EventStorageSeverity = {
	Info : 1,
	Warning : 2,
	Critical : 3
}; // ic.EventStorageSeverity

ic.OASTaskErrorReason = {
	Unknown : 0,
	IncorrectUser : 1,
	IncorrectGroup : 2,
	IncorrectPath : 3,
	InterceptorNotFound : 4
}; // ic.OASTaskErrorReason

ic.ODSTaskErrorReason = {
	Unknown : 0,
	IncorrectPath : 1
}; // ic.ODSTaskErrorReason

ic.HeuristicLevel = {
	Light : 1,
	Medium : 2,
	Deep : 3,
	Recommended : 4
}; // ic.HeuristicLevel

ic.KeyType = {
	"0" : "Unknown",
	"1" : "Beta",
	"2" : "Trial",
	"3" : "Test",
	"4" : "OEM",
	"5" : "Commercial",
	_:'_'
};
ic.KeyRestriction = {
	"0" : "Unknown",
	"1" : "Valid",
	"2" : "Expired",
	"3" : "Corrupted",
	"4" : "Not signed",
	"5" : "Wrong product",
	"6" : "Black listed",
	"7" : "Bases are newer then the key expiration date",
	"8" : "Bases wrong or corrupted",
	"9" : "Key creation date invalid",
	"10" : "Trial already in use",
	"11" : "Invalid blacklist",
	"12" : "Can't be used as supplementary key",
	"13" : "Key install date invalid",
	"14" : "Trial period is over",
	"15" : "Conflict with installed commercial key",
	_:'_'
};
ic.EventObjectID = {
	ApplicationStartedEvent : 7169,
	ApplicationShutdownEvent : 7170,
	ApplicationSettingsChangedEvent : 7171,
	PackedObjectDetectedEvent : 2,
	ThreatDetectedEvent : 3,
	ObjectProcessedEvent : 4,
	ObjectNotProcessedEvent : 5,
	ObjectProcessingErrorEvent : 6,
	ObjectDisinfectedEvent : 7,
	ObjectNotDisinfectedEvent : 8,
	ObjectDeletedEvent : 9,
	ObjectBlockedEvent : 10,
	ObjectActionsCompletedEvent : 11,
	EventsMoved : 7269,
	EventsErased : 7270,
	LicenseInstalledEvent : 3073,
	LicenseNotInstalledEvent : 3074,
	LicenseRevokedEvent : 3075,
	LicenseNotRevokedEvent : 3076,
	LicenseExpiredEvent : 3077,
	LicenseExpiresSoonEvent : 3078,
	LicenseErrorEvent : 3079,
	ThreatDetected : 5221,
	ObjectProcessingError : 5222,
	ObjectCurable : 5223,
	FalseDetect : 5224,
	PasswordProtected : 5225,
	Corrupted : 5226,
	ObjectAddedToQuarantine : 5121,
	ObjectAddedToBackup : 5122,
	ObjectRemovedFromQuarantine : 5123,
	ObjectRemovedFromBackup : 5124,
	ObjectRestoredFromQuarantine : 5125,
	ObjectRestoredFromBackup : 5126,
	SizeLimitReached : 5127,
	SoftSizeLimitExceeded : 5128,
	ObjectAddToQuarantineFailed : 5129,
	ObjectAddToBackupFailed : 5130,
	TaskSettingsChangedEvent : 6145,
	TaskStateChangedEvent : 6146,
	OASTaskErrorEvent : 6147,
	ODSTaskErrorEvent : 6148,
	AVBasesAttachedEvent : 2049,
	AVBasesAreOutOfDateEvent : 2050,
	AVBasesAreTotallyOutOfDateEvent : 2051,
	UpdateSourceSelectedEvent : 2052,
	UpdateSourceNotSelectedEvent : 2053,
	NothingToUpdateEvent : 2054,
	ModuleDownloadedEvent : 2055,
	ModuleNotDownloadedEvent : 2056,
	AVBasesIntegrityCheckOKEvent : 2057,
	AVBasesIntegrityCheckFailedEvent : 2058,
	ModuleRetranslatedEvent : 2059,
	ModuleNotRetranslatedEvent : 2060,
	UpdateErrorEvent : 2061,
	RetranslationErrorEvent : 2062,
	AVBasesRollbackCompletedEvent : 2063,
	AVBasesRollbackErrorEvent : 2064,
	AVBasesAppliedEvent : 2065
};

ic.Reason = {
	ObjectProcessedSource : {
		Unknown : 0,
		LocalFile : 1,
		RemoteSambaFile : 2,
		RemoteNfsFile : 3
	},
	ObjectProcessedReason : {
		Unknown : 0,
		ExcludedByICheck : 1,
		ExcludedByCache : 2,
		ExcludedByMinSize : 3,
		ObjectClean : 4
	},
	ObjectProcessingErrorReason : {
		Unknown : 0,
		InternalError : 1,
		ObjectIOError : 2,
		ObjectReadOnly : 3,
		SystemError : 4,
		AccessDenied : 5,
		OutOfSpace : 6,
		ObjectCorrupted : 7,
		ObjectNotFound : 8
	},
	ObjectNotProcessedReason : {
		Unknown : 0,
		Encrypted : 1,
		PwdProtected : 2,
		ExcludedByMaxSize : 4,
		ExcludedByType : 5,
		ExcludedByExcludeMasks : 6,
		ExcludedByTime : 7,
		ExcludedByExcludeThreats : 8
	},
	ObjectNotDisinfectedReason : {
		Unknown : 0,
		InternalError : 1,
		ObjectIOError : 2,
		ObjectReadOnly : 3,
		SystemError : 4,
		AccessDenied : 5,
		OutOfSpace : 6,
		ObjectCorrupted : 7,
		ObjectNotFound : 8,
		ExcludedByTime : 9,
		ObjectNotCurable : 10
	},
	ObjectActionsCompletedReason : {
		Unknown : 0,
		Cured : 1,
		Removed : 2,
		Quarantined : 4,
		Skipped : 5,
		AllActionsFailed : 6
	},
	DetectCertainty : {
		Unknown : 0,
		Sure : 1,
		Warning : 2,
		Suspicion : 3
	},
	OASTaskErrorReason : {
		Unknown : 0,
		IncorrectUser : 1,
		IncorrectGroup : 2,
		IncorrectPath : 3,
		InterceptorNotFound : 4
	},
	ODSTaskErrorReason : {
		Unknown : 0,
		IncorrectPath : 1
	}
}; // ic.Reason

ic.TraceLevel = {
	Unknown : 0,
	Fatal : 1,
	Error : 2,
	Info : 4,
	Warning : 3,
	Debug : 5
}; // ic.TraceLevel

ic.Schedule = {};
ic.Schedule.DayOfWeek = {
	Unknown : 0,
	Mon : 1,
	Tue : 2,
	Wed : 3,
	Thu : 4,
	Fri : 5,
	Sat : 6,
	Sun : 7,
	WorkDays : 8,
	WeekEnd : 9
}; // ic.Schedule.DayOfWeek

ic.Schedule.Month = {
	Unknown : 0,
	Jan : 1,
	Feb : 2,
	Mar : 3,
	Apr : 4,
	May : 5,
	Jun : 6,
	Jul : 7,
	Aug : 8,
	Sep : 9,
	Oct : 10,
	Nov : 11,
	Dec : 12
}; // ic.Schedule.Month

ic.Schedule.DayType = {
	Unknown : 0,
	DayOfMonth : 1,
	DayOfWeek : 2
}; // ic.Schedule.DayType

ic.Schedule.StartRuleType = {
	Manual : 0,
	Once : 1,
	Weekly : 2,
	Monthly : 3,
	Hourly : 4,
	Minutely : 5,
	Daily : 6,
	BasesReload : 7,
	Startup : 8
}; // ic.Schedule.StartRuleType

ic.Schedule.ActionType = {
	Unknown : 0,
	Start : 1
}; // ic.Schedule.ActionType

ic.Schedule.QueryType = {
	Unknown : 0,
	Time : 1,
	BaseReload : 2,
	Startup : 3
}; // ic.Schedule.QueryType

ic.Quarantine = {};
ic.Quarantine.ErrorType = {
	Ok : 0,
	Unknown : 1,
	Add : 2,
	Get : 3,
	GetOne : 4,
	Remove : 5,
	Update : 6,
	Restore : 7,
	SizeLimit : 8,
	Export : 9,
	Import : 10
}; // ic.Quarantine.ErrorType

ic.Quarantine.ErrorReason = {
	Unknown : 0,
	FileExist : 1,
	FileNotExist : 2,
	FileBusy : 3,
	FileClosed : 4,
	BadFile : 5,
	PermissionDenied : 6,
	BadFolder : 7,
	NoMemory : 8,
	DatabaseError : 9,
	SizeLimitReached : 10,
	InvalidOperation : 11,
	InvalidArguments : 12
}; // ic.Quarantine.ErrorReason

