function auth_prepareLoginForm()
{
	var $div  = $('#div_login');
	$div.find('>div').bgIframe();
	var user  = $div.find('#username').get(0);
	var pass  = $div.find('#userpass').get(0);
	var $btn  = $div.find('#authSubmitButton');
	$btn.disable();
	$div.find('#userpass,#username')
		.fastChange(function(){
			var len1 = user.value.length;
			var len2 = pass.value.length;
			if( len1 && len2 )
				$btn.enable();
			else
				$btn.disable();
		})
		.onEnter(function(){
			$btn.click();
		});
}

function auth_userLogin()
{
	ic.userLogin(
		$('#username').val(),
		$('#userpass').val(),
		function(response){
			if(response.errorMsg) {
				if (response.errorMsg.indexOf("Connection error : connect()") > -1)
					$('#div_login').find('#errorBox').html(_res('CONSOLIDATE_STATUS_CONN_LOST'));
				else
				  $('#div_login').find('#errorBox').html(_res('ERROR_AUTH_' + response.errorMsg.toUpperCase().replace(/\W/gm,'_')));
				return;
			}
			$('#div_login').find('#errorBox').html('');
			$('#userpass').val('');
			var twoWeeks = 60 * 60 * 24 * 14;
			ic.storage.save('sid', response.sid, twoWeeks);
			misc_hideLoginForm();
			checkUrlUpdate();
			ic.processPendingRequests();
		})

	return true;
}

function auth_userLogout()
{
	ic.storage.save('sid', '');

	// <clear> essential data in memory
	editTask.Init();
	summaryListFunc.response = null;
	// </clear>

	window.location.href = '#summary';
	checkUrlUpdate();
	summaryPage_hideInfoElements();
	$('#consolidateStatus_text').html('')
	$('#table_bodyContent').find('.red,.yellow').attr('class', 'green');
	$('#table_bodyContent').find('.red_tab,.yellow_tab').attr('class', 'green_tab');
	misc_showLoginForm();
}
