function ctlEditUsers(rootElement)
{
	var ctl_ = this;
	var vo_  = new voEditUsers(rootElement, ctl_);

	ctl_.getUsers = function(callback)
	{
		ic.listUsers(function(response){
			if(ic.ajaxError(response))
				alert(response.errorMsg) // FIXME
			else
				callback(response);
		})
	}
	ctl_.getGroups = function(callback)
	{
		ic.listGroups(function(response){
			if(ic.ajaxError(response))
				alert(response.errorMsg) // FIXME
			else
				callback(response);
		})
	}

	ctl_.getSelectedUsers = function()
	{
		return ctl_.selectedUsers_;
	}

	ctl_.getSelectedGroups = function()
	{
		return ctl_.selectedGroups_;
	}

	ctl_.selectedUsers_  = [];
	ctl_.selectedGroups_ = [];
	ctl_.usageFlag_      = false;

	ctl_.update = function(users, groups, usageFlag)
	{
		ctl_.selectedUsers_  = users;
		ctl_.selectedGroups_ = groups;
		ctl_.usageFlag_      = usageFlag;
		vo_.update();
	}

	var changeTimeout_ = 0;

	function triggerChange()
	{
		clearTimeout(changeTimeout_);
		changeTimeout_ = setTimeout(function(){
			$(rootElement).trigger('onChangeSettings.voDialog');
		}, 100);
	}

	ctl_.setUsageFlag = function(usageFlag)
	{
		ctl_.usageFlag_ = usageFlag;
		triggerChange();
	}
	ctl_.addSelectedUser = function(user)
	{
		ctl_.selectedUsers_.push(user);
		triggerChange();
	}
	ctl_.removeSelectedUser = function(user)
	{
		ctl_.selectedUsers_.removeValue(user);
		triggerChange();
	}
	ctl_.addSelectedGroup = function(group)
	{
		ctl_.selectedGroups_.push(group);
		triggerChange();
	}
	ctl_.removeSelectedGroup = function(group)
	{
		ctl_.selectedGroups_.removeValue(group);
		triggerChange();
	}
}
