// ODS New task wizard
function dlgNewODSWizard(params)
{
	var params_ = $.extend({}, params);

	params_.showScopes   = true;
	params_.showSettings = true;
	params_.showMasks    = true;
	params_.showSchedule = true;
	params_.enableNext   = true;

	var impl_ = new baseDlg(params_);
	var dlg_  = this;

	dlg_.settings_ = {};
	dlg_.params_   = {};

	function settingsChanged(params)
	{
		dlg_.params_ = params;
	}
	function okClicked(callback)
	{
		var params = dlg_.params_;
		for(var idx = 0, len = params.scanScopes.length; idx < len; ++idx)
		{
			var scope = params.scanScopes[idx];

			scope.ScanSettings = params.scanSettings;
			scope.AreaMask     = params.includeObjects;
			scope.ScanSettings.ExcludeMasks   = params.excludeObjects;
			scope.ScanSettings.ExcludeThreats = params.excludeThreats;
			scope.ScanSettings.UseExcludeMasks   = params.useExcludeObjects;
			scope.ScanSettings.UseExcludeThreats = params.useExcludeThreats;

			dlg_.settings_.ScanScope[idx] = scope;
		}
		dlg_.settings_.schedule = this.schRule;

		ic.createTask(dlg_.taskName_, ic.TaskClass.ODS, dlg_.settings_, callback);
	}

	function nextClicked(callback)
	{
		callback({});
	}

	this.open = function(taskName, settings)
	{
		dlg_.taskName_ = taskName;
		dlg_.settings_ = settings;

		var params = dlg_.params_;
		params.scanScopes   = settings.ScanScope;
		params.scanSettings = settings.ScanScope[0].ScanSettings;
		params.includeObjects = [];
		params.excludeObjects = [];
		params.excludeThreats = [];
		params.useExcludeObjects = false;
		params.useExcludeThreats = false;

		params.schRule     = ic.create_Schedule_ScheduleSettings();

		params.settingsChanged = settingsChanged;
		params.okClicked       = okClicked;
		params.nextClicked     = nextClicked;

		impl_.open(params);
	}
	this.close = function()
	{
		impl_.close();
	}
}
