/*
Usage:
====================HTML PART BEGIN====================
<table>
    <tr>
	<!-SELECT CONTROL AREA-->
	<td id="rcpt_list" style="width:156"></td>

	<!-BUTTON AREA-->
	<td>
	    <table>
                <tr>
			<td><a href="#" id="rcpt_list_buttons" class="res:LABEL_EDIT_MODE"/></td>
                </tr>
                <tr>
			<td id="rcpt_add_buttons" style="padding-left:0px; padding-right:0px"></td>
		</tr>
		<tr>
		        <td id="rcpt_edit_buttons" style="padding-left:0px; padding-right:0px"></td>
            	</tr>
		<tr>
		        <td id="rcpt_remove_buttons" style="padding-left:0px; padding-right:0px"></td>
                </tr>
	    </table>
        </td>
    </tr>
</table>
====================HTML PART END====================
multiSelectList({
			base_name:     "rcpt",
			store:	  RecipientsArray,
			onchange: ChangeCallback,
			width:      150,
			height:     100,
			select_list:  ValueArrayForSelectList,
			elem : $('table'),
			click2edit : true
});
*/

function multiSelectList(data)
{
	var __list = this;

	this.elem = $(data.elem || document.body);

	this.storage = data.store;
	this.base_name = data.base_name;
	this.click2edit = true;
	if(typeof(data.click2edit) != 'undefined')
		this.click2edit = data.click2edit;

	this.onRemove = (typeof(data.onRemove) == 'function' ? data.onRemove : function(){} );

//	data.select_list = ["val1","val2","val3","val4","val5"];
	this.select_list = [];
	if(typeof(data.select_list) != 'undefined' ) 	this.select_list = data.select_list;

	this.width = 250;
	if(typeof(data.width) != 'undefined' ) this.width = data.width;

	this.height = 170;
	if(typeof(data.height) != 'undefined' ) this.height = data.height;

	this.onchangeCallback = null;
	if (typeof(data.onchange) != 'undefined') this.onchangeCallback=data.onchange;

	this.last_select     = -1;
	this.isFullView      = false;
	this.mouseOutList    = true;
	this.editBorderWidth = 1;
	this.enabled         = true;

	this.editStyle      = 'style="width:'+(__list.width-2*__list.editBorderWidth)+'px; background: #f8f8f8; font-size: 9pt; font-family:Tahoma;  padding: 0px; margin:0px; border: solid '+__list.editBorderWidth+'px #9cb7ce"';
	this.entryStyle     = 'style="width:100%; padding:0px; -moz-user-select:none; -moz-user-select:-moz-none;"';
	this.mainDivStyle   = 'style="border:1px solid #9cb7ce; overflow:auto; background-color:white; width:'+__list.width+'px; height:'+__list.height+'px"';
	this.mainTableStyle = 'style="padding:0px; width:100%;"';
	this.disableDivBgColor   = "#f8f8f8";

	__list.elem.find('#'+__list.base_name+'_list').html('<div id="'+__list.base_name+'_list_div" '+__list.mainDivStyle+' onselectstart="return false">'+
		  '<table id="'+__list.base_name+'_list_tbl" '+__list.mainTableStyle+' onselectstart="return false"></table>'+
		  '</div>');

	__list.elem.find('#'+__list.base_name+'_list_div').click(function(){
		if(__list.mouseOutList){
		    clearSelected();
		    repaintButtons();
		}
	});
	
	__list.elem.find('#'+__list.base_name+'_list_tbl').mouseout(function(){
	    __list.mouseOutList=true;
	});
	
	__list.elem.find('#'+__list.base_name+'_list_tbl').mouseover(function(){
	    __list.mouseOutList=false;
	});

	this.list  = __list.elem.find('#'+__list.base_name+'_list_tbl');

	var buttonTmpl = new Template(
	'<a href="#" id="#{buttonName}"><img src="#{buttonImg}" alt="#{buttonAlt}" title="#{buttonAlt}"/></a>' +
//	'<span id="#{buttonName}"><img src="#{buttonImg}" alt="#{buttonAlt}" title="#{buttonAlt}"/></span>' +
	'<span id="#{buttonName}_grey"><img src="#{buttonGreyImg}" /></span>');

	var buttonEdit_params = {
		buttonName     : __list.base_name+"_edit",
		buttonImg      : "./img/buttons/edit.gif",
		buttonAlt      : "Edit",
		buttonGreyImg  : "./img/buttons/edit_grey.gif"
	};
	var buttonDel_params = {
		buttonName     : __list.base_name+"_remove",
		buttonImg      : "./img/buttons/del.gif",// "./img/buttons/del.gif",
		buttonAlt      : "Delete",
		buttonGreyImg  : "./img/buttons/deldis.gif"// "./img/buttons/del_grey.gif"
	};
	var buttonAdd_params = {
		buttonName     : __list.base_name+"_add",
		buttonImg      : "./img/buttons/add.gif", // "./img/buttons/plus.gif",
		buttonAlt      : "Add",
		buttonGreyImg  : "./img/buttons/adddis.gif" // "./img/buttons/plus_grey.gif"
	};
    	__list.elem.find('#'+__list.base_name+'_edit_buttons').html(buttonTmpl.evaluate(buttonEdit_params));
    	__list.elem.find('#'+__list.base_name+'_remove_buttons').html(buttonTmpl.evaluate(buttonDel_params));
    	__list.elem.find('#'+__list.base_name+'_add_buttons').html(buttonTmpl.evaluate(buttonAdd_params));

	this.add_btn       = __list.elem.find('#'+__list.base_name+'_add')
	this.add_btn_grey  = __list.elem.find('#'+__list.base_name+'_add_grey')
	this.del_btn       = __list.elem.find('#'+__list.base_name+'_remove')
	this.del_btn_grey  = __list.elem.find('#'+__list.base_name+'_remove_grey')
	this.edit_btn      = __list.elem.find('#'+__list.base_name+'_edit')
	this.edit_btn_grey = __list.elem.find('#'+__list.base_name+'_edit_grey')
	this.list_btn      = __list.elem.find('#'+__list.base_name+'_list_buttons')

	this.edit_btn.css("display","none");
	this.del_btn.css("display","none");
	this.add_btn_grey.css("display","none");
/*
//Block for support standalone EditBox for add new list element
//temporary not supported
	this.entry = $('#'+__list.base_name+'_entry');

	function addNewItem(){
		val= $(__list.entry).val();
		if (val.length>0){
			addListOption(__list.list, __list.storage.length, val, false);
			__list.storagee.push(val);
			$(__list.entry).val('').focus();
			do_onchange();
		};
	};

	this.entryKeyHandler = function(event){
		if(event.keyCode==13)
			addNewItem();
	};
//	entry.keypress(enterKeyHandler).keyup(enterKeyHandler);
*/

	function do_onchange(){
		if(typeof(__list.onchangeCallback) === 'function') {
			__list.onchangeCallback();
		}
	};

	function getSelectedCount(){
		var count_selected = 0;
		__list.elem.find("div[id^='"+__list.base_name+"_']").each(
			function (){
				if($(this).hasClass("kl_list_option_select")) count_selected++;
			}
		)
		return count_selected;
	};

	this.enableList=function(enable){
		__list.enabled = enable;
		__list.edit_btn.css("display","none");
		__list.edit_btn_grey.css("display","block");
		__list.del_btn.css("display","none");
		__list.del_btn_grey.css("display","block");
		if(enable){
			__list.add_btn.css("display","block");
			__list.add_btn_grey.css("display","none");
			__list.elem.find('#'+__list.base_name+'_list_div').css("background-color", "white");
		}else{
			__list.add_btn.css("display","none");
			__list.add_btn_grey.css("display","block");
			__list.elem.find('#'+__list.base_name+'_list_div').css("background-color", __list.disableDivBgColor);
		}
	}

	
	function repaintButtons(){
		var count_select = getSelectedCount();

		__list.edit_btn.css("display","none")
		__list.edit_btn_grey.css("display","block")
		__list.del_btn.css("display","block")
		__list.del_btn_grey.css("display","none")

		if (count_select==0) {
			__list.edit_btn.css("display","none")
			__list.del_btn.css("display","none")
			__list.edit_btn_grey.css("display","block")
			__list.del_btn_grey.css("display","block")
		}

		if (count_select==1) {
			__list.edit_btn.css("display","block")
			__list.del_btn.css("display","block")
			__list.edit_btn_grey.css("display","none")
			__list.del_btn_grey.css("display","none")
		}
	}

	function clearSelected(){
		__list.elem.find("div[id^='"+__list.base_name+"_']").each(function (){
			$(this).removeClass("kl_list_option_select");
		});
	};

	this.selectKeyHandler = function(event){
		if(!__list.enabled) return;
		var modifier = 0;
		if(event.ctrlKey)  modifier = 1;
		if(event.shiftKey) modifier = 2;
		entry_id= this.id
		
		if (modifier==0) {
			clearSelected();
			$(this).addClass("kl_list_option_select")
		}else if(modifier==2){
			name1_array = entry_id.split("_")
			name2_array = __list.last_select.split("_")
			var num1 = parseInt(name1_array[name1_array.length-1])
			var num2 = parseInt(name2_array[name2_array.length-1])
			for(var i=Math.min(num1,num2);i<=Math.max(num1,num2);i++){
				__list.elem.find('#'+__list.base_name+"_"+i).addClass("kl_list_option_select")
			}
		}else if(modifier==1){
			$(this).toggleClass("kl_list_option_select")
		}
		repaintButtons();
		__list.last_select = entry_id;
	};

	function getEntryText(val){
	    _val = val;
	    if(_val==='') _val = "&nbsp;";
	    return '<div style="padding:'+__list.editBorderWidth+'px; margin:0px;" class="nobr">'+misc_preparetoView(_val)+'</div>';
	}
	function addListOption(list, list_idx, val, selected){
		var new_entry_id = __list.base_name+'_'+list_idx;
		list.append('<tr><td '+__list.entryStyle+' onselectstart="return false;"><div id="'+new_entry_id+'" style="padding:0px; margin:0px;">'+getEntryText(val)+'</div></td></tr>')
		if (__list.elem.find('#'+__list.base_name+'_remove').length==1){
			__list.elem.find('#'+new_entry_id).click(__list.selectKeyHandler);
			if(__list.click2edit)
				__list.elem.find('#'+new_entry_id).dblclick(function(){
					if($(this).hasClass("kl_list_option_select"))
						__list.editSelectedEntry();
				});
		}
		if(selected)
		    __list.elem.find('#'+new_entry_id).addClass("kl_list_option_select");

	};

	this.drawList = function(){
		//__list.storage.sort();
		__list.list.empty();
		var list_idx=0;
		$(__list.storage).each(function(){
			addListOption(__list.list, list_idx, this, false);
			list_idx++;
		});
	};

	this.editSelectedEntry = function(){
		if(!__list.enabled) return;

		if( getSelectedCount()!=1) return;

		__list.elem.find("div[id^='"+__list.base_name+"_']").each(	function (){
			if($(this).hasClass("kl_list_option_select")) {
				edit_id = __list.base_name+"_edit_text";
				$(this).removeClass("kl_list_option_select");
				repaintButtons();

				name_array = $(this).attr("id").split("_");
				num = parseInt(name_array[name_array.length-1]);
				edit_value = "";
				if(typeof( __list.storage[num]) != 'undefined'){
				    edit_value =  __list.storage[num];
				}
				$(this).html($('<input id="'+edit_id+'" type="text" '+__list.editStyle+' value="">').val(edit_value));
				__list.elem.find('#'+edit_id)
					.fastChange( __list.editKeyHandler)
					.onEnter( __list.enterKeyHandler);
				__list.elem.find('#'+edit_id).blur( function(){
					if ($(this).val()!=''){
					    $(this).parent().html(getEntryText($(this).val()));
					}else{
					    __list.storage.removeIndexes(num);
					    __list.onRemove(num);
					    __list.drawList();
					}
					__list.add_btn_grey.css("display","none");
					__list.add_btn.css("display","block");
				})
				__list.elem.find('#'+edit_id).focus().select();
			}
		});

	}



	this.editKeyHandler = function(event){
		name_array = $(this).parent().attr("id").split("_")
		num = parseInt(name_array[name_array.length-1]);
		if ($(this).val()!='') {
			__list.storage[num] = $(this).val();
		}
		do_onchange();
	};
	
	this.enterKeyHandler = function(event){
		name_array = $(this).parent().attr("id").split("_")
		num = parseInt(name_array[name_array.length-1]);
		if ($(this).val()!=''){
			$(this).parent().html(getEntryText($(this).val()));
		}else{
			__list.storage.removeIndexes(num);
			__list.onRemove(num);
			__list.drawList();
		}
		__list.add_btn_grey.css("display","none");
		__list.add_btn.css("display","block")
		repaintButtons();
		if ($(this).val()!='') {
			__list.storage[num] = $(this).val();
		}
		do_onchange();
	};

	function setHref(){
// 		this.href = window.location.href;
	};
	
	this.del_btn.each(setHref).click(function(){
		if(!__list.enabled) return false;

		var to_del=[];
		__list.elem.find("div[id^='"+__list.base_name+"_']").each(
			function (){
				if($(this).hasClass("kl_list_option_select")) {
					name_array = $(this).attr("id").split("_");
					num = parseInt(name_array[name_array.length-1]);
					to_del.push(num);
					$(this).remove();
				}
			}
		)
		__list.storage.removeIndexes(to_del);
		__list.onRemove(to_del);
		do_onchange();
		__list.drawList();
		repaintButtons();
		return false;
	});

	this.edit_btn.each(setHref).click(function(){
		if(!__list.enabled) return false;

		__list.editSelectedEntry();
		return false;
	});

	this.add_btn.each(setHref).click(function(){
		if(!__list.enabled) return false;

		__list.add_btn.css("display","none");
		__list.add_btn_grey.css("display","block");
		__list.edit_btn.css("display","none")
		__list.edit_btn_grey.css("display","block")
		__list.del_btn.css("display","none")
		__list.del_btn_grey.css("display","block")
		clearSelected();
		addListOption(__list.list, __list.storage.length, '', true);
		__list.editSelectedEntry();
		return false;
	});

	this.addToList = function(_value){
		__list.add_btn.css("display","none");
		__list.add_btn_grey.css("display","block");
		__list.edit_btn.css("display","none")
		__list.edit_btn_grey.css("display","block")
		__list.del_btn.css("display","none")
		__list.del_btn_grey.css("display","block")
		clearSelected();
		addListOption(__list.list, __list.storage.length, _value, false);
	};

	this.list_btn.each(setHref).click(function(){
		if(!__list.enabled) return false;

		function inArray(element,array_){
			for(var i=0;i<array_.length;i++){
				if (element.localeCompare(array_[i])==0) 
					return i;
			}
			return -1;
		}

		function unique(array_){
			var result = new Array()
			for(var i=0;i<array_.length;i++){
				num = $.inArray(array_[i],array_);
				if (i==num)
				    result.push(array_[i]);
			}
			return result;
		}
//		__list.list.html("&nbsp;");
		__list.list.html(" ");
		if (__list.isFullView) {
			__list.list_btn.html(_res('LABEL_EDIT_MODE'));
			__list.isFullView = false;
			__list.drawList();
			return false;
		}
		__list.isFullView = true;
		__list.list_btn.html(_res('LABEL_VIEW_MODE'));
			
		var list_view_A = __list.storage.concat(__list.select_list);
		list_view_A = unique(list_view_A);
		list_view_A.sort();

		var list_view = new Array();

		$(list_view_A).each(function(){
			f_list = (inArray(this,__list.select_list)>=0)
			f_select = (inArray(this,__list.storage)>=0)
			list_view.push({value:this,select:f_select,isList:f_list})
		});

		num = 0
		$(list_view).each(function(){
			if(this.select)
				__list.list.append('<tr><td style="padding:0px 5px;"><input type="checkbox" checked id="'+__list._base_name+'_list_'+num+'" value="'+this.value+'">'+this.value+'</td></tr>')
			else
				__list.list.append('<tr><td style="padding:0px 5px;"><input type="checkbox" id="'+__list.base_name+'_list_'+num+'" value="'+this.value+'">'+this.value+'</td></tr>')
			__list.elem.find('#'+__list.base_name+'_list_'+num).click(function(){
				if ($(this).attr("checked")) {
					__list.storage.push($(this).val());
				}else{
					to_del=[]
					to_del.push(inArray($(this).val(),__list.storage));
					__list.storage.removeIndexes(to_del);
					__list.onRemove(to_del);
				}
				do_onchange();
			});
			num++
		});
		return false;


	});
	__list.drawList();
};
