function Resources()
{
	var self_ = this;

	this.data_  = {};
	this.files_ = [];
	this.onFileLoaded   = function(file){}
	this.onLoadComplete = function(){}

	var resourceDirectory = '/resource/';

	function setGlobalResource(lres)
	{
		Resource = lres;
	}

	function parseResourceFile(file, responseText)
	{
		try {
			eval(responseText);
			setGlobalResource(Resource);
			self_.files_.push(file);
			self_.data_[file] = Resource;
			self_.onFileLoaded(file);
		}
		catch(e){
			alert("Internal error: invalid resource file " + file + ":" + e)
		}
	}

	function loadNextResourceFile(getNextFileFunc)
	{
		var file;
		if((file = getNextFileFunc()) != null) {
			function nextHandler(responseText)
			{
				parseResourceFile(file, responseText);
				loadNextResourceFile(getNextFileFunc);
			}
			try{
				jQuery.get(resourceDirectory + file, nextHandler, 'html');
			}
			catch(e){}
		}
		else
			self_.onLoadComplete();
	}

	function parseResourceList(responseText)
	{
		var re = /<A HREF="(resource_\S{2}.js)">/ig;
		var getNextFileFunc = function()
		{
			if((what = re.exec(responseText)) != null)
				return what[1];
			return null;
		}
		loadNextResourceFile(getNextFileFunc);
	}

	this.load = function()
	{
		try {
			jQuery.get(resourceDirectory, {}, parseResourceList, 'html');
		}
		catch(e){}
	}
};

function setCurrentResourceFile()
{
	Resource = resources.data_[this.value];
	ic.storage.save('iconsole_lang', this.value);
	window.location.reload();
}

function getCurrentResourceFile()
{
	if(ic.storage.get('iconsole_lang') === null)
		return 'resource_en.js';

	return ic.storage.get('iconsole_lang');
}
