var tasksList =
{
	items   : new Array(),
	changed : function(t0,t1){
		return (t0.state != t1.state)
			|| (t0.prevState != t1.prevState)
			|| (t0.name != t1.name);
	},
	get : function(resp,taskClass){
		if(ic.ajaxError(resp))
			return;

		var actual = new Array();
		var change = new Array();
		var list = this.items[taskClass].list;
		var item;
		while(item = resp.shift()){
			if(list[item.id] === undefined)
				item.change='add';
			else if(this.changed(list[item.id], item))
				item.change='chg';
			else
				item.change='non';
			change.push(item);
			actual[item.id] = item;
		}

		for(var idx = 0; idx < list.length; ++idx)
		{
			if(list[idx] === undefined)
				continue;

			var item = list[idx];

			if(actual[item.id] === undefined){
				item.change = 'del';
				change.push(item);
			}
		}
		this.items[taskClass].list = actual;
		this.items[taskClass].callback(change);
	},

	update : function(callback,taskClass)
	{
		if(this.items[taskClass] === undefined)
			this.items[taskClass] = {
				callback : function(items){},
				list     : new Array()
			};

		this.items[taskClass].callback = callback;

		function requestCallback(resp){
			tasksList.get(resp,taskClass)
		}
		ic.getTaskList(requestCallback, taskClass);
	},

	clear : function(taskClass){
		if(this.items[taskClass] === undefined)
			return;

		this.items[taskClass].list.length = 0;
	}
};

ic.registerConnectionErrorHandler(function(){
	if(0 == $('#tasksListPageMarker').length )
		return;

	$('#rollbackBasesLink,#createReportLink').hide();
	searchForm.setTableStatus(_res('SUMMARY_NOT_AVAILABLE'))
})

ic.registerConnectionRestoredHandler(function(){
	if(0 == $('#tasksListPageMarker').length)
		return;

	$('#createReportLink').show();

	if(locDesc.clazz == ic.TaskClass.Update)
		$('#rollbackBasesLink').show();

	searchForm.run();
})
