function UT_ASSERT(s)
{
	if(!eval(s))
		throw s + " FAILED";
}

var tests = new Array();

tests.push([ 2, function(){
	window.location.hash = '#rtp'
}])

tests.push([ 0, function(){
	UT_ASSERT("$('#summaryTable').length > 0");
}])

tests.push([ 2, function(){
	window.location.hash = '#rtp/__schedule__'
}])

tests.push([ 2, function(){
	window.location.hash = '#rtp/__scope__';
}])

tests.push([ 0, function(){
	UT_ASSERT("$('#tableArea').length == 1");
	UT_ASSERT("$('#rtp_new_fsname').length == 1");
}])

tests.push([ 2, function(){
	window.location.hash = '#rtp/__excludescope__';
}])

tests.push([ 3, function(){
	window.location.hash = '#rtp/__stat__';
}])

tests.push([ 3, function(){
	window.location.hash = '#quarantine'
}])

tests.push([ 3, function(){
	window.location.hash = '#backup'
}])

function runTest(idx)
{
	try{
		tests[idx][1]();
		if((idx+1) < tests.length)
			setTimeout("runTest(" + (idx+1) + ")",
				tests[idx][0] * 1000);
		else
			setTimeout("alert('Tests completed successfully')",
				tests[idx][0] * 1000);
	}
	catch(e){
		alert(e + ' in ' + tests[idx][1].toString())
	}
}

function runsuite()
{
	runTest(0);
}
