function Timer(func)
{
	var key_ = func;

	if(typeof(timers_) === 'undefined')
		timers_ = {};

	this.clear = function()
	{
		clearTimeout(timers_[key_]);
		timers_[key_] = 0;
	}

	this.set = function(ms)
	{
		var currentHref = window.location.href;
		var timeoutFunc = function()
		{
			if(window.location.href === currentHref)
				func();
		}
		clearTimeout(timers_[key_]);
		timers_[key_] = setTimeout(timeoutFunc, ms);
	}

	this.clear();
}
