
function getTable(struct_table){
/*
	id  - id table
	title
		selected : true/false
		keys : key of titleColumn
	data : data of rows
	group_action
		
*/
	/* alert( getElementTemplate('table',{
		id:struct_table.id,
		title:getTableTitle(struct_table.title),
		rows:getTableRowData(struct_table),
		group_action:struct_table.group_action
	}) )
	*/
	 return getElementTemplate('table',{
		id:struct_table.id,
		title:getTableTitle(struct_table.title),
		rows:getTableRowData(struct_table),
		group_action:struct_table.group_action
	})
	
}

function getTableTitle(title){
	
	var result = ""
	if (title.selected) result = getElementTemplate('table_titleCheckbox',{id:'1'})
	$.each(title.keys,function(i,item){
			result+=getElementTemplate('table_titleColumn_width',{
				widthColumn:title.width[i],
				nameColumn:getLocalString(item)
				})
	});
	//alert(result)
	return getElementTemplate('table_title',{titleColumn:result})
}

function getTableRowData(struct_table){
	var result=""
	$.each(struct_table.data,function(i,item){
		var row_data = "";
		if (struct_table.title.selected) row_data = getElementTemplate('table_column_checkbox',{id:"cell"+i+"0"})
		for(var j=0;j<item.length;j++) {
		//alert("("+item[j].link+")")
			item[j].id = "cell"+i+(j+1)
			if (item[j].link=="")
				row_data+= getElementTemplate('table_column',item[j])
			else	
				row_data+= getElementTemplate('table_column_link',item[j])
				
		}
		//alert(1)	
		result+=getElementTemplate('table_row',{id:"row"+i,row:row_data})		
	});
	return result
}
