function EditTaskModel(){
	var model = this;

	this.isChangeTask = true
	this.SettingsTask = null
	this.ScheduleTask = null
	this.isSettingsTaskChange = false
	this.isScheduleTaskChange = false
	this.loadCallback =  null
	this.taskInfo  =null

	this.isInitSettingsTask = false
	this.isInitScheduleTask = false

	this.Init = function(){
		model.SettingsTask = null
		model.ScheduleTask = null
		model.isSettingsTaskChange = false
		model.isScheduleTaskChange = false
		model.taskInfo  =null
	}

	this.isInitFinish = function(){
		return 	model.isInitSettingsTask &&
				model.isInitScheduleTask ;

	}

	this.isEditActive = function(){
		if (model.taskInfo==null) return false;
	/*	if (model.taskInfo.clazz!=ic.TaskClass.Update)
			return false
		else*/
		return model.isChangeTask &&
			(model.isSettingsTaskChange || model.isScheduleTaskChange);
	}

	this.setTask = function(taskInfo_, callback){
		this.stopClick = false;
		var result = false;
		//alert("setTask "+Object.toJSON(taskInfo_))
		if (model.taskInfo!=null) {
			if (taskInfo_.id ==null) {
				model.isChangeTask = true
			//	model.Init();
			//	return
			}

			if (taskInfo_.clazz== ic.TaskClass.OAS ) {
				if (model.taskInfo.clazz == taskInfo_.clazz)
					model.isChangeTask = false;
				else
				    model.isChangeTask = true;
			}
			else
			if (model.taskInfo.id == taskInfo_.id && model.taskInfo.clazz == taskInfo_.clazz)
				model.isChangeTask = false;
			else
			    model.isChangeTask = true;

		}
		else model.isChangeTask = true

		model.loadCallback = null;

		if (taskInfo_.clazz== ic.TaskClass.Update && taskInfo_.id!=null) {
			model.loadCallback = callback;
			result = true
		}
		if (taskInfo_.clazz== ic.TaskClass.OAS) {
			model.loadCallback = callback;
			result = true
		}
		if (taskInfo_.clazz== ic.TaskClass.Notifier) {
			model.loadCallback = callback;
			result = true
		}
		if (taskInfo_.clazz== ic.TaskClass.Snmp) {
			model.loadCallback = callback;
			result = true
		}
		if (taskInfo_.clazz== ic.TaskClass.ODS && taskInfo_.id!=null) {
			model.loadCallback = callback;
			result = true
		}
		if (taskInfo_.clazz== ic.TaskClass.QS && taskInfo_.id!=null) {
			model.loadCallback = callback;
			result = true
		}


		if(editTask.isEditActive()) {
			if(confirm(_res("MESSAGE_CHANGES_SAVED")))
				this.Init()
			else {
				this.stopClick = true;
				return true;
			}
		}
		if(model.isChangeTask)
		{
			model.taskInfo = Object.clone(taskInfo_);
			model.SettingsTask = null;

// 			var isGeneralTab = (0 == findTabByHref());
// 			if(isGeneralTab && (typeof(model.loadCallback) == 'function') && taskInfo_.clazz!=ic.TaskClass.Notifier) {
			if(typeof(model.loadCallback) === 'function') {
				model.loadCallback();
				model.loadCallback = 0;
			}
			model.getSettings();
		}
		else{
			// this case call callback if settings already in memory and load is not required
			// but this call is unavailable if  settings loading in progress
			if( model.isInitFinish() )
				if( typeof(model.loadCallback) == 'function' )
					model.loadCallback();
		}
		return result
	}

	this.getSettings = function(taskInfo_)
	{
		if(taskInfo_)
			model.taskInfo = { id : taskInfo_.id, clazz : taskInfo_.clazz };

		if(model.taskInfo.id==null){
			if(model.taskInfo.clazz==ic.TaskClass.OAS) {
				model.isInitSettingsTask = false
				model.isInitScheduleTask = false
				ic.getRTPTask(getSettingsOAS);
				return
			}
			if(model.taskInfo.clazz == ic.TaskClass.Notifier) {
				model.isInitSettingsTask = false
				model.isInitScheduleTask = false
				ic.getNotifierTask(getSettingsNotifier);
				return
			}
			if(model.taskInfo.clazz == ic.TaskClass.Snmp) {
				model.isInitSettingsTask = false
				model.isInitScheduleTask = false
				ic.getSnmpTask(getSettingsNotifier);
				return
			}
			else {
				model.Init();
				return
			}
		}

		if(model.taskInfo.id > 0) {
			model.isInitSettingsTask = false
			model.isInitScheduleTask = false
			ic.getTask(model.taskInfo.id, function(resp){
				if(ic.ajaxError(resp))
					return;
				if(resp.name)
					model.taskInfo.name = resp.name;
				ic.getTaskSettings(model.taskInfo.id, getSettingsTask);
				ic.getTaskSchedule(model.taskInfo.id, getScheduleTask);
			})
		}
		else {
			alert("Warning model.taskInfo.id("+model.taskInfo.id+") <0 : Use testing data from data.js")
			getSettingsTask(null)
			getScheduleTask(null)
		}
	}

	function getSettingsNotifier(response){
		if(ic.ajaxError(response))
			return;

		model.taskInfo.id = response.id
		ic.getTaskSettings(model.taskInfo.id, getSettingsTask);
		getScheduleTask({});
	}

	function getSettingsOAS(response)
	{
		if(ic.ajaxError(response))
			return;

		model.taskInfo.id = response.id
		ic.getTaskSettings(model.taskInfo.id, getSettingsTask);
		ic.getTaskSchedule(model.taskInfo.id, getScheduleTask);
	}

	function getSettingsTask(response)
	{
		if(ic.ajaxError(response)) {
			model.SettingsTask = ic.create_UpdateSettings();
			return;
		}
		model.isInitSettingsTask = true;
		model.SettingsTask       = response;
		model.SettingsForRevert  = jQuery.extend(true, {}, model.SettingsTask);

		if(model.isInitFinish() && jQuery.isFunction(model.loadCallback))
			model.loadCallback();
	}

	function getScheduleTask(response){
		if(ic.ajaxError(response)) {
			model.ScheduleTask = ic.create_Schedule_ScheduleSettings();
			return;
		}
		model.isInitScheduleTask = true;
		model.ScheduleTask       = response;
		model.ScheduleForRevert  = jQuery.extend(true, {}, model.ScheduleTask);

		if(model.isInitFinish() && jQuery.isFunction(model.loadCallback))
		    model.loadCallback();
	}

	this.revertSettings = function()
	{
		model.SettingsTask = jQuery.extend(true, {}, model.SettingsForRevert);
		model.ScheduleTask = jQuery.extend(true, {}, model.ScheduleForRevert);

		//model.getSettings(model.taskInfo);
		model.setButtonSaveEnabled(false);
		model.isSettingsTaskChange = false;
		model.isScheduleTaskChange = false;
	}

	// Save settings error
	ic.errorHandlers.push(function(data) {
		if(data.errorMsg && (true === model.processingSaveSettings)) {
			$('#settingsErrorBox').updateHtml(data.errorMsg);
			return true;
		}
		return false;
	})

	ic.registerConnectionErrorHandler(function(){
		if(true === model.processingSaveSettings){
			$('#b_SaveSettings').enable();
			showConnectionLostAchtung();
		}
	})

	function saveSettingsResponse(response)
	{
		$('#settingsStatusBox').html('');

		if(response.errorMsg == 'ALREADY_MODIFIED') {
			if(confirm(_res('TASK_SETTINGS_MODIFIED')))
			{
				model.saveSettings(true);
			}
			else
			{
				$('#b_SaveSettings,#b_RevertSettings').enable();
				$('#settingsStatusBox').html(_res('TASK_SETTINGS_CANCELED'));
			}
		}
		else if(ic.ajaxError(response)) {
			$('#b_RevertSettings').enable();
		}
		else {
			model.SettingsTask.ctime = response.time;
			model.SettingsForRevert = jQuery.extend(true, {}, model.SettingsTask);
			model.ScheduleForRevert = jQuery.extend(true, {}, model.ScheduleTask);
			$('#settingsStatusBox').html(_res('TASK_SETTINGS_SAVED'));
		}
		model.processingSaveSettings = false;

		if(jQuery.isFunction(model.onSettingsSaved))
			model.onSettingsSaved(response);
	}

	this.saveSettings = function(skipCtimeCheck)
	{
		model.processingSaveSettings = true;
		$('#settingsErrorBox').html('');
		$('#settingsStatusBox').html(_res('TASK_SETTINGS_SAVING'));
		$('#b_SaveSettings,#b_RevertSettings').disable();
		model.isSettingsTaskChange = false;
		model.isScheduleTaskChange = false;

		ic.setTaskSettingsAndSchedule(
			model.taskInfo.id,
			model.SettingsTask,
			model.ScheduleTask,
			saveSettingsResponse,
			skipCtimeCheck);
	}

	this.setSettingsTaskChange =function () {
		model.isSettingsTaskChange = true
		model.setButtonSaveEnabled(true)
	}

	this.setScheduleTaskChange = function () {
		model.isScheduleTaskChange = true
		model.setButtonSaveEnabled(true)
	}

	this.setButtonSaveEnabled = function (f){
		if (f) {
			$('#b_SaveSettings').removeAttr("disabled")
			$('#b_RevertSettings').removeAttr("disabled")
		}
		else {
			$('#b_SaveSettings').attr("disabled","disabled")
			$('#b_RevertSettings').attr("disabled","disabled")
		}
	}

	this.initButtonSaveEnabled = function (){
		model.setButtonSaveEnabled(model.isSettingsTaskChange || model.isScheduleTaskChange)

	}
}

function editTask_SettingsTaskCompleted()
{
	return (typeof(editTask.SettingsTask) != 'undefined')
		&& (editTask.SettingsTask != null);
}

function editTask_ScheduleTaskCompleted()
{
	return (typeof(editTask.ScheduleTask) != 'undefined')
		&& (editTask.ScheduleTask != null);
}
