FunctionStore =
{
	id_   : 1,
	busy_ : false,
	hash_ : new Object(),

	register : function(functor, domElement, funcName)
	{
		if(!domElement) {
			alert('DOM id must be specified for FunctionStore.register');
			return;
		}

		if(typeof(domElement) === 'string')
		{
			$sel = $('#' + domElement);
			if( 0 == $sel.length )
				return;

			domElement = $sel.get(0);
		}
		else if(!domElement.id) {
			alert('domElement must contain "id"');
			return;
		}

		id = (++this.id_) + '_' + domElement.id;
		domElement['function_' + id] = functor;
		return id;
	},

	createExpr : function(functor, domId, funcName)
	{
		id = this.register(functor, domId, funcName);
		return "FunctionStore.invoke('" + id + "')";
	},

	createLink : function(functor, domId, funcName)
	{
		return "javascript:" + this.createExpr(functor, domId, funcName);
	},

	invoke : function(id)
	{
		domId = id.substring(id.indexOf('_') + 1);
		func  = $('#' + domId).attr('function_' + id);
		if(jQuery.isFunction(func))
			func();
	}
};
// FunctionStore.garbageCollect();
