TYPE_MWINDOW_BUTTON_OK = 0
TYPE_MWINDOW_BUTTON_OK_CANCEL = 1
TYPE_MWINDOW_BUTTON_YES_NO = 2

var numEditCell = -1
var numEditColumn = -1

function showModal(data){
	$('#mwindow_show').empty()
	$('#mwindow_show').append(getElementTemplate('mwindow_show',data))
	$('#mwindow').css('display','block');
}

function getSLButtons(type){
	var buttons = ""
	switch(type){
		case TYPE_MWINDOW_BUTTON_OK: buttons= getElementTemplate('mwindow_button',
								{	name:getLocalString("BUTTON_OK"),
									func:"hideSHSettings()"
								})
								break
		case TYPE_MWINDOW_BUTTON_OK_CANCEL: buttons=
								getElementTemplate('mwindow_button',
									{	name:getLocalString("BUTTON_OK"),
									func:"hideSHSettings()"
									})+
								getElementTemplate('mwindow_button',
									{	name:getLocalString("BUTTON_CANCEL"),
										func:"hideSHSettings()"
									})
									break

	}
	return getElementTemplate('mwindow_buttons',{buttons:buttons});
}

function showEditSLCell(id,columnNum){

	if (numEditCell!=id || numEditCell<0) {
		hideSLSettings()
		numEditCell=id
		var str = '<tr id="modw1" style="background:#FFF">'
			str+='<td style="border-top:none"><div class="szh"></div>'
			//str+='<td style="border-top:none"><div height=350px></div>'
			str+='</td>' //'<div style="height:344px"></div></td>'
			str+='<td style="border-top:none"></td>'
			str+='<td colspan="3" class="modalwin t" style="background:#F8F8F8">'
			str+='<div id="mwindown_panel" style="height:344px"></div>'+getSLButtons(TYPE_MWINDOW_BUTTON_OK_CANCEL)+'</td>'
			//str+='<div id="mwindown_panel"></div>'+getSLButtons(TYPE_MWINDOW_BUTTON_OK_CANCEL)+'</td>'
			str+='</tr>'
		$("#row"+id).after(str)
		$("#cell"+id+"0").css("border-bottom","none")
		$("#cell"+id+"1").css("border-bottom","none")
	}

	var pageName="error.html"
	switch(columnNum){
		case 2: pageName="rtp_sl_actions.html"
			$("#cell"+id+"2").html(getElementSelect({options:[getLocalString("SECURITY_LEVEL_MAX_PROTECTION"),
				getLocalString("SECURITY_LEVEL_RECOMMENDED"),getLocalString("SECURITY_LEVEL_HIGH_SPPED"),
				getLocalString("SECURITY_LEVEL_CUSTOM")],
					text:getLocalString("SECURITY_LEVEL_RECOMMENDED"),
					id:"sl_actions"}) )
			break
		case 3: pageName="rtp_scan_objects.html"
			break
		case 4: pageName="rtp_users_group.html"
			break
	}
	switch(numEditColumn){
		case 2:
			var selectedIndex = $("#sl_actions").attr("selectedIndex")
			$("#cell"+id+"2").html("<a href='javascript:showEditSLCell("+id+",2)'>"+getLocalString("SECURITY_LEVEL_RECOMMENDED")+"</a>")
			//$("#cell"+id+"2").html(getColumnSecurityLevel(id,""))
			//alert($("#cell"+id+"2").parent().html())
			break
		case 3: //pageName="rtp_scan_objects.html"
			break
		case 4: //pageName="rtp_users_group.html"
			break
	}

		$("#cell"+id+columnNum).css("border-bottom","solid 1px #F8F8F8")
		$("#cell"+id+columnNum).css("background","#F8F8F8")
	if (numEditColumn>=0) {
		$("#cell"+id+numEditColumn).css("border-bottom","solid 1px #999")
		$("#cell"+id+numEditColumn).css("background","none")
	}
		numEditColumn = columnNum

	loadSLPage(pageName)
}




function showSchRuleStartPanel(title,panel){
	var data  =new Object()
	data.title 		= getMWindowTitle(getLocalString(title))
	data.panel 		= getElementTemplate('mwindow_panel',"")
	data.buttons 	= ""//getMWindowButtons(TYPE_MWINDOW_BUTTON_OK)
	showModal(data)
	loadSchPage("startRule.html")
}

function showEditStartRuleCell(id,columnNum,num){
	if (numEditCell!=id || numEditCell<0) {
	hideSHSettings(true)
	numEditCell = id
		var str = '<tr id="modw1" style="background:#FFF">'
			str+='<td style="border-top:none"><div id="mwindown_cell" height=350px></div>'
			str+='</td>'
			str+='<td style="border-top:none"></td>'
			str+='<td class="modalwin t" style="background:#F8F8F8">'
			str+='<div id="mwindown_panel" style="height:344px;"></div></td>'
			str+='</tr>'
		$("#row"+id).after(str)
		$("#cell"+id+"0").css("border-bottom","none")
		$("#cell"+id+"1").css("border-bottom","none")
	}

	var pageName="error.html"
	switch(columnNum){
		case 2: //pageName="rtp_sl_actions.html"
			$("#cell"+id+"2").html(getElementSelectValue(
				{
					options:[
						[getLocalString("SCH_START_RULETYPE_TIME"),SCH_START_RULETYPE_TIME],
						[getLocalString("SCH_START_RULETYPE_STARTUP"),SCH_START_RULETYPE_STARTUP],
						[getLocalString("SCH_START_RULETYPE_BASES_RELOAD"),SCH_START_RULETYPE_BASES_RELOAD]
					],
					text:getLocalString(getSchStartRuleDescrption(schedule.start_rules[num])),
					id:"select_start_rule",
					func:"onchange = selectStartRule("+id+","+num+")"
				}
			) )
			break
	}
		$("#cell"+id+columnNum).css("border-bottom","solid 1px #F8F8F8")
		$("#cell"+id+columnNum).css("background","#F8F8F8")
		numEditColumn = columnNum

	$("#mwindown_panel").html("<div id='startRule"+id+columnNum+"'/>")
	$("#select_start_rule").trigger('change')

}
function showEditStopRuleCell(id,columnNum,num){
	//alert("showEditStopRuleCell id="+id)
	if (numEditCell!=id || numEditCell<0) {
		hideSHSettings(false)
		numEditCell = id

		var str = '<tr id="modw1" style="background:#FFF">'
			str+='<td style="border-top:none"><div id="mwindown_cell" height=350px></div>'
			str+='</td>'
			str+='<td style="border-top:none"></td>'
			str+='<td class="modalwin t" style="background:#F8F8F8">'
			str+='<div id="mwindown_panel" style="height:344px;"></div></td>'
			str+='</tr>'
		$("#row"+id).after(str)
		$("#cell"+id+"0").css("border-bottom","none")
		$("#cell"+id+"1").css("border-bottom","none")
	}

	var pageName="error.html"
	switch(columnNum){
		case 2: //pageName="rtp_sl_actions.html"
			$("#cell"+id+"2").html(getElementSelectValue(
				{
					options:[
						[getLocalString("SCH_STOP_RULETYPE_DURATION_LIMIT"),SCH_STOP_RULETYPE_DURATION_LIMIT],
						[getLocalString("SCH_STOP_RULETYPE_DURATION_INTERVAL"),SCH_STOP_RULETYPE_DURATION_INTERVAL],
						[getLocalString("SCH_STOP_RULETYPE_TIME_INTERVAL"),SCH_STOP_RULETYPE_TIME_INTERVAL],
						[getLocalString("SCH_STOP_RULETYPE_BASES_RELOAD"),SCH_STOP_RULETYPE_BASES_RELOAD]

					],
					text:getLocalString(getSchStopRuleDescrption(schedule.stop_rules[num])),
					id:"select_stop_rule",
					func:"onchange = selectStopRule("+id+","+num+")"
				}
			) )
			break
	}
		$("#cell"+id+columnNum).css("border-bottom","solid 1px #F8F8F8")
		$("#cell"+id+columnNum).css("background","#F8F8F8")
	/*if (numEditColumn>=0) {
		$("#cell"+id+numEditColumn).css("border-bottom","solid 1px #999")
		$("#cell"+id+numEditColumn).css("background","none")
	}*/
		numEditColumn = columnNum

	$("#mwindown_panel").html("<div id='stopRule"+id+columnNum+"'/>")
	$("#select_stop_rule").trigger('change')
}



function hideSLSettings(){
	$("#modw1").remove()
	if (numEditColumn>=0) {
		switch(numEditColumn){
			case 2:
				var selectedIndex = $("#sl_actions").attr("selectedIndex")
				$("#cell"+numEditCell+"2").html("<a href='javascript:showEditSLCell("+numEditCell+",2)'>"+getLocalString("SECURITY_LEVEL_RECOMMENDED")+"</a>")
				break
			case 3: //pageName="rtp_scan_objects.html"
				break
			case 4: //pageName="rtp_users_group.html"
				break
		}

	}
	numEditCell = -1
	numEditColumn = -1
}

function hideSHSettings(isStart){
	/*str = "javascript:showEditStopRuleCell("

	if (isStart) str="javascript:showEditStartRuleCell("

	$("#modw1").remove()
	if (numEditCell>=0) {
		$("#cell"+numEditCell+"2").html("<a href='"+str+numEditCell+",2)'>"+select_Sch_Type+"</a>")
		$("#cell"+numEditCell+"2").css("border-bottom","solid 1px #999")
		$("#cell"+numEditCell+"2").css("background","none")
	}
	numEditCell = -1
	numEditColumn = -1*/
}

function loadSLPage(name){
	$("#mwindown_panel").load("pages/settingsTask/"+name);
}
function loadSchPage(name){
	//alert(1)
	$("#mwindown_panel").load("pages/scheduler/"+name);
}
