var TemplateOASScope = new Array()
	TemplateOASScope['table']		= new Template('<table id=#{id} class="#{className}">#{title}#{rows}#{group_action}</table>')
//	TemplateOASScope['table']		= new Template('#{title}#{rows}')
	TemplateOASScope['title'] 		= new Template('<tr class="title">#{titleColumn}</tr>')
	TemplateOASScope['titleColumn']	= new Template('<td>#{nameColumn}</td>')
	TemplateOASScope['titleColumn_width']	= new Template('<td style="width:60%">#{nameColumn}</td>')
	TemplateOASScope['titleCheckbox']= new Template('<td class="w0"><input type="checkbox"></td>')
	
	TemplateOASScope['task_row'] 	= new Template('<tr id="#{id}">#{row}</tr>')
	TemplateOASScope['column'] 	= new Template('<td id="cell#{id}"><a href=#{link}>#{name}</a</td>')
	TemplateOASScope['column_img'] 	= new Template('<td id="cell#{id}"><a href="#{link}">#{name}</a</td>')
	TemplateOASScope['column_checkbox']= new Template('<td id="cell#{id}" class="w0"><input type="checkbox"></td>')
	
	TemplateOASScope['actions_LSS'] 	= new Template('<tr><td>#{label}</td><td>#{select1}</td><td>#{select2}</td></tr>')
	TemplateOASScope['actions_CHSS'] 	= new Template('<tr><td><inpit type="checkbox" id="#{id}">#{label}</td><td>#{select1}</td><td>#{select2}</td></tr>')
	TemplateOASScope['actions_select'] 	= new Template('<select id="#{id}">#{options}</select>')
	TemplateOASScope['actions_select_option'] 	= new Template('<option #{selected}>#{option}</option>')

	 

var TaskSettings = null

function testOASSettings(){
	getSettingsOAS(TestODSTaskSettings)
}

/*-------------------------------------*/
function getSettingsOAS(data){
	TaskSettings= data//alert(1)
	getSettingsTable(data);
}

function getTemplate(key,data){
	//alert("getTemplate "+key)
	return getElementTemplate(key,data)//TemplateOASScope[key].evaluate(data);
}

function getSettingsTable(data){
	  var group_action ='<tr class="tools">'+
			'<td colspan="2">'+
				'<img src="./img/arr_green_up.gif" alt="Up"/>'+
				'<img src="./img/arr_green_dw.gif" alt="Down"/>'+
				'<img src="./img/close.gif" alt="Delete"/>'+
			'</td>'+
			'<td>'+
				'<select>'+
					'<option>'+getLocalString('SECURITY_LEVEL_MAX_PROTECTION')+'</option>'+
					'<option>'+getLocalString('SECURITY_LEVEL_RECOMMENDED')+'</option>'+
					'<option>'+getLocalString('SECURITY_LEVEL_HIGH_SPPED')+'</option>'+
					'<option>'+getLocalString('SECURITY_LEVEL_CUSTOM')+'</option>'+
				'</select>'+
			'</td>'+
			'<td colspan="2">'+
				'<input type="button" value="'+getLocalString('BUTTON_SET')+'" style="width:80px" class="brd"/>'+
			'</td>'+
		'</tr>'
		
	 //	$('#mdm').append(getTemplate('table',
	 	$('#mdm').append(/*getTable('table',
				 			{
				 				id:'tasks_list',
				 				className:'w100 tabl',
				 				title:getSettingsTableTitle(),
				 				rows:getTaskList(data),
				 				group_action:group_action
				 			}
	 					)*/
							getTable(
								{
									id:"tasks_list",
									title:{
										selected : true,
										keys : ["TABLE_TITLE_SCAN_AREA","TABLE_TITLE_SECURITY_LEVEL","TABLE_TITLE_SCAN_OBJECTS","TABLE_TITLE_USERS_GROUPS"],
										width : ["25%","25%","25%","25%"]
										},
									data : getSettingList(data),
									group_action:group_action									
								}
							 )
	 )


}

function getSettingsTableTitle(){
	var result = getTemplate('table_titleCheckbox',"")
	title = ["TABLE_TITLE_SCAN_AREA","TABLE_TITLE_SECURITY_LEVEL","TABLE_TITLE_SCAN_OBJECTS","TABLE_TITLE_USERS_GROUPS"]
	$.each(title,function(i,item){
		if (i==0)
			result+=getTemplate('table_titleColumn_width',{nameColumn:getLocalString(item)})
		else
			result+=getTemplate('table_titleColumn',{nameColumn:getLocalString(item)})
	});
	//alert(result)
	return getTemplate('table_title',{titleColumn:result})
}

function getColumnScanArea(i,item){
	return getTemplate('table_column',{id:""+i+"1",link:'#',name:item.area_path.fs_path})
	
}

function getColumnSecurityLevel(i,item){
	var obj = item.scan_settings
	return getTemplate('table_column',{id:""+i+"2",link:'javascript:showEditSLCell('+i+',2);',name:getLocalString('SECURITY_LEVEL_RECOMMENDED')})
}

function getColumnScanObjects(i,item){
	return getTemplate('table_column',{id:""+i+"3",link:'javascript:showEditSLCell('+i+',3);',name:item.area_mask})
}

function getColumnUsersGroups(i,item){
	return getTemplate('table_column',{id:""+i+"4",link:'javascript:showEditSLCell('+i+',4);',name:item.access_user.user_name+','+item.access_user.user_group})
	
}
function getSettingList(data){
	var result=new Array()
	$.each(data.scan_scope,function(i,item){
	/*	var row_data = getTemplate('table_column_checkbox',{id:""+i+"0"})
		row_data+=getColumnScanArea(i,item)+getColumnSecurityLevel(i,item)+
				getColumnScanObjects(i,item)+getColumnUsersGroups(i,item)
		result+=getTemplate('table_row',{id:"row"+i,row:row_data})		
	*/
		result[i]= new Array()
		result[i][0] = {link:"",name :item.area_path.fs_path}
		result[i][1] = {link:'javascript:showEditSLCell('+i+',2);',name:getLocalString('SECURITY_LEVEL_RECOMMENDED')}
		result[i][2] = {link:'javascript:showEditSLCell('+i+',3);',name:item.area_mask}
		result[i][3] = {link:'javascript:showEditSLCell('+i+',4);',name:item.access_user.user_name+','+item.access_user.user_group}
		
	});
	return result
}

function paintSettingsActions(num){
	$('#task_settings').remove()
	$('#editSettings').append(
		getTemplate('table',{id:'task_settings',className:'w100',title:"",rows:getActionsList(TaskSettings.scan_scope[num].scan_settings)}))
}

function getActionsList(settings){
/*	var ActionWare = 
		[
			{
				template:'actions_LSS',
				key:'TSA_LABEL_INFECTED_FILES',
				label:getLocalString('TSA_LABEL_INFECTED_FILES'),
			},
			{
				template:'actions_LSS',
				key:'TSA_LABEL_INFECTED_FILES',
				label:getLocalString('TSA_LABEL_INFECTED_FILES'),
			},
			
	
	
		]*/
	
	
	var result=getTemplate('actions_LSS',
						{
							label:getLocalString('TSA_LABEL_INFECTED_FILES'),
							select1:getActionsSelect(settings.infected_first_action),
							select2:getActionsSelect(settings.infected_second_action)
						}
					)
	result+=getTemplate('actions_LSS',
						{
							label:getLocalString('TSA_LABEL_SUSPICIOUS_FILES'),
							select1:getActionsSelect(settings.suspicious_first_action),
							select2:getActionsSelect(settings.suspicious_second_action)
						}
	
	
					)
	result+=getTemplate('actions_CHSS',
						{
							label:getLocalString('TSA_LABEL_VIRWARE'),
							select1:getActionsSelect(settings.suspicious_first_action),
							select2:getActionsSelect(settings.suspicious_second_action)
						}
					)
	return result;				
} 

function getActionsSelect(actions){
	var Options = [
					['TSA_SELECT_OPTION_CURE',OAS_ACTION_CURE],
					['TSA_SELECT_OPTION_REMOVE',OAS_ACTION_REMOVE],
					['TSA_SELECT_OPTION_RECOMMENDED',OAS_ACTION_RECOMMENDED],
					['TSA_SELECT_OPTION_QUARANTINE',OAS_ACTION_QUARANTINE],
					['TSA_SELECT_OPTION_SKIP',OAS_ACTION_SKIP]
				 ]
	var options =""
	for(var i=0;i<Options.length;i++){
		var obj = {selected:'',option:getLocalString(Options[i][0])}
		if (Options[i][1]==actions) 
			obj.selected = "selected" 
		options+=getTemplate('actions_select_option',obj)
	}
	return getTemplate('actions_select',{
							id:"ch1",
							options:options
						})
}

function getSettingsSecurityLevel(){
	
}




