var testStatusRTP = new StatusRTP(STATUS_RTP_STOPPED,0,0)
var TestODSTaskSettings =
			{
				scan_scope:
					[
						{
							area_path:
								{
									fs_path:'/usr1',
									fs_type:FSTYPE_MOUNTED,
									fs_NAME:FSNAME_SAMBA,
									fs_SHARE:'my share' 
									
								},
							area_mask:['.txt','.tmp','*.ertwerter' ],
							access_user:
								{
									user_name:['user1','user2'],
									user_group:['group1']
								},
							area_desc:'This is a test scan area',
							scan_settings:
							{
								scan_type					:SCAN_TYPE_ALLOBJECTS,
								scan_archived				:true,
								scan_sfx_archived			:true,
								scan_mail_bases				:true,
								scan_plain_mail				:true,
								scan_packed					:true,
								use_time_limit				:true,
								time_limit					:5, // sec
								use_size_limit				:true,
								size_limit					:1024, // bytes
								scan_access_type			:OAS_ACCESSTYPE_OPEN,
								infected_first_action		:OAS_ACTION_SKIP,
								infected_second_action		:OAS_ACTION_REMOVE,
								suspicious_first_action		:OAS_ACTION_QUARANTINE,
								suspicious_second_action	:OAS_ACTION_REMOVE,
								use_advanced_actions		:true,
								advanced_actions			:[
																{
																	verdict:VERDICT_TYPE_VIRWARE,
																	first_action:OAS_ACTION_CURE,
																	second_action:OAS_ACTION_CURE
																}
																],
								use_exclude_masks			:true,
								exclude_masks				:['exc.1','exc.2'],
								use_exclude_threats			:false,
								exclude_threats				:[],
								use_ichecker				:true,
								report_clean_objects		:true,
								report_packed_objects		:true
							}
						},
						{
							area_path:
								{
									fs_path:'/usr2',
									fs_type:FSTYPE_MOUNTED,
									fs_NAME:FSNAME_SAMBA,
									fs_SHARE:'my share' 
									
								},
							area_mask:['.txt','.tmp'],
							access_user:
								{
									user_name:['user1','user2'],
									user_group:['group1']
								},
							area_desc:'This is a test scan area',
							scan_settings:
							{
								scan_type					:SCAN_TYPE_ALLOBJECTS,
								scan_archived				:true,
								scan_sfx_archived			:true,
								scan_mail_bases				:true,
								scan_plain_mail				:true,
								scan_packed					:true,
								use_time_limit				:true,
								time_limit					:5, // sec
								use_size_limit				:true,
								size_limit					:1024, // bytes
								scan_access_type			:OAS_ACCESSTYPE_OPEN,
								infected_first_action		:OAS_ACTION_CURE,
								infected_second_action		:OAS_ACTION_REMOVE,
								suspicious_first_action		:OAS_ACTION_QUARANTINE,
								suspicious_second_action	:OAS_ACTION_REMOVE,
								use_advanced_actions		:true,
								advanced_actions			:[
																{
																	verdict:VERDICT_TYPE_VIRWARE,
																	first_action:OAS_ACTION_CURE,
																	second_action:OAS_ACTION_CURE
																}
																],
								use_exclude_masks			:true,
								exclude_masks				:['exc.1','exc.2'],
								use_exclude_threats			:false,
								exclude_threats				:[],
								use_ichecker				:true,
								report_clean_objects		:true,
								report_packed_objects		:true
							}
						}
						
					],
					
				excluded_from_scan_scope:
					[
						{
							area_path:
								{
									fs_path:'/usr',
									fs_type:FSTYPE_MOUNTED,
									fs_NAME:FSNAME_SAMBA,
									fs_SHARE:'my share' 
									
								},
							area_mask:['.txt','.tmp'],
							access_user:	
								{
									user_name:['user1','user2'],
									user_group:['group1']
								},
							area_desc:'This is a test excluded from scan area'	
						}
					]
			}

